#!/usr/bin/perl

#  Welcome to the www.dtp-aus.com ennyForms script - version 2.07c Mch 2001  #
#  IMPORTANT INFORMATION THAT MUST BE READ IF YOU WISH TO USE THESE SCRIPTS  #
##############################################################################
# The script "ENNYFRMS.CGI" was written (c) by Ron F Woolley, Melbourne      #
# Australia. Copyright 1998-2001. This script can be altered for personal    #
# site use or commercial site use EXCEPT THAT:                               #
# ALL COPYRIGHT NOTICES must remain in the code, visible on all output pages,#
# AND ALL of the header notices MUST REMAIN intact as is,                    #
# AND using the script without first reading the README.HTM, is prohibited.  #
#                                                                            #
# Australian copyright is recognised/supported in over 130 countries...      #
# per the Berne Convention and other treaties. (including USA!)              #
#                                                                            #
#  The scripts and associated files REMAIN the property of Ron F Woolley.    #
#  NO PROFIT what so ever is to be gained from users of these scripts for    #
#  installation of these scripts, except that a reasonable minimal charge    #
#  for installation MAY be allowed. Supply, per installation, is directly    #
#  from dtp-aus.com ONLY. Remote hosting of this program is strictly         #
#  not allowed.                                                              #
#                                                                            #
#  Ron Woolley, the author, MUST be notified via the addresses/URLs below    #
#  if any gain is to be made for the installation of these scripts.          #
#                                                                            #
##############################################################################
# NOTE: If you use these files, you do so entirely at your own risk, and     #
# take on full responsibility for the consequences of using the described    #
# files. You must first agree that Ron Woolley / HostingNet, the only        #
# permitted supplier of this and/or accompanying files is exempt from any    #
# responsibility for all or any resulting problems, losses or costs caused   #
# by your using these or any associated files. If you disagree with ANY of   #
# the included requirements, you must IMMEDIATELY DESTROY ALL FILES.         #
##############################################################################
#   This program script is free to use   Copyright notices must remain       #
##############################################################################
#  These program scripts are free-to-use, but if you use them, a donation to #
# the author would be appreciated and help in continuing support for         #
# ennyForms and the creation of other scripts for users of the internet.     #
# An on-line Visa / MasterCard payment cart is available for support         #
# donations and low cost program installations.                              #
##############################################################################
# Support Information is available at:                                       #
#    http://www.dtp-aus.com/cgiscript/scrpthlp.htm                           #
# Files from:                                                                #
#    http://www.dtp-aus.com/cgiscript/afrmscrp.shtml                         #
# All script descriptions are at:                                            #
#    http://www.dtp-aus.com/cgiscript/allcgi.shtml                           #
#                                                                            #
#  THESE FILES can only be obtained via the above web addresses, and MUST    #
#  NOT BE PASSED ON TO OTHERS in any form by any means what so ever.         #
#           This does not contradict any other statements above.             #
##############################################################################
# TO KEEP IT FREE, WE NEED your support on link and resource listing sites!  #

#--- Alter these two paths only (TWICE), if needed! ----#
	if (-s "sets/gmtset.pl") {require "sets/gmtset.pl";} else {print "Content-type: text/html\n\n"; print "Missing/Bad Path to GMTime file\n"; exit;}
	if (-s "sets/enyfrmset.pl") {require "sets/enyfrmset.pl";} else {print "Content-type: text/html\n\n"; print "Missing/Bad Path to Config file\n"; exit;}
#--- Do Not make any changes below this line. ----------#

# ALL COPYRIGHT and NAME NOTICES MUST remain in the code and output pages, visible as is.
# I do not include any links back to the site as many programs do; appreciate free programming!

	&check_method;
		&ref_ok;
		
sub chk_addr {
    local($chk) = $_[0];
	open (RJ, "<$enymre_path/rejects.txt"); ($boofheds=join ' ',<RJ>)=~s/(\r\n|\n)/ /sg; close(RJ); $boofheds.=" ";
	if ($boofheds =~ /(^| )($ENV{'REMOTE_ADDR'} |$chk )/i) {
		print "Content-type: text/html\n\n"; 
		open (RH, "<$enymre_path/rejects.htm");
			while ($LIn=<RH>) {$LIn=~s/%%RTRN%%/$INS{'return'}/; print $LIn;} close(RH); exit(0);
	}
    if ($chk =~ /(.*@.*\.[a-zA-Z]{2,3}$)/ && $chk !~ /(^\.)|(\.$)|( )|(\.\.)|(@\.)|(\.@)|(@.*@)/) {return;}
    else {$err_lst .= "<b>Email Address</b> <font color=\"#000000\">Error Detected</font><br>";}
}
sub chk_len {
	local($s1,$s2,$s3) = ($_[0],$_[1],$_[2]);
	if (length($s2) > $s1) {$err_lst .= "<b>$labels[$s3]</b> input too long <font color=\"#000000\">($s1 char max)</font><br>";}
}
sub ref_ok {
	$crf = 0;
	if ($ENV{'HTTP_REFERER'}) {
        foreach $referer (@referers) {
            if ($ENV{'HTTP_REFERER'} =~ m|\Ahttps?://([^/]*)$referer|i) {
                $crf = 1;
                last;
      } }   }
    if ($crf eq 0) {&err_msg("bad referrer</b> ( $ENV{'HTTP_REFERER'} )<br>remote access not permitted. Use only<br>forms and links ON SITE!<b>");}
}
sub check_method {
	local($request_method) = $ENV{'REQUEST_METHOD'};
	if ($request_method eq 'GET') {$query_string = $ENV{'QUERY_STRING'};}  
	elsif ($request_method eq 'POST') {read(STDIN,$query_string, $ENV{'CONTENT_LENGTH'});}
	else {&err_msg('Illegal Method');}
   return
}
sub date_time {
   local($which) = @_;
   my($sec,$min,$hour,$mday,$mon,$year,$wday);
   ($sec,$min,$hour,$mday,$mon,$year,$wday) = gmtime(time + $gmtPlusMinus);
   	if ($year < 39) { $year = "20$year" }
   	elsif ($year > 99 && $year < 2000) { $year = 2000 + ( $year - 100 ) }
   	elsif ($year > 38) { $year = "19$year" }
      local($apm = "am");
   if ($which == 3) {
	if (!$dtUS) {return sprintf("%02d\/%02d\/%04d-%02d:%02d",$mday,$mon + 1,$year,$hour,$min);}
	elsif ($dtUS eq "1") {return sprintf("%02d\/%02d\/%04d-%02d:%02d",$mon + 1,$mday,$year,$hour,$min);}
	else {return sprintf("%04d\/%02d\/%02d-%02d:%02d",$year,$mon + 1,$mday,$hour,$min);}
   }
      local(@mnths) = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
      local(@days) = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
      if ($hour > 11) {$apm = "pm";}
      if ($hour > 12) {$hour =  $hour - 12;}
   if (!$which) {return sprintf("$days[$wday] $mday $mnths[$mon] %04d %02d:%02d:%02d$apm",$year,$hour,$min,$sec);}
   elsif ($which == 1){
	if (!$dtUS) {return  sprintf("%02d\/%02d\/%04d-%02d:%02d$apm",$mday,$mon + 1,$year,$hour,$min);}
	elsif ($dtUS eq "1") {return sprintf("%02d\/%02d\/%04d-%02d:%02d$apm",$mon + 1,$mday,$year,$hour,$min);}
	else {return sprintf("%04d\/%02d\/%02d-%02d:%02d$apm",$year,$mon + 1,$mday,$hour,$min);}
   }
   elsif ($which == 2) {return sprintf("%02d%02d",$mon + 1,$mday);}
}
sub get_adrfle {
		my $fnm = shift;
	my ($file,$adrin,$ex);
	if (!$fnm) {
		$file = lc ($INS{'frmName'}); $ex = "adr";
		$file =~ s/\W//g;
		($file = substr($file,0,8));
	} else {$file = $fnm; $ex = "rcv"}
	if (-s "$edat_path/$file.$ex" && open(AF,"<$edat_path/$file.$ex")) {
		$adrin = <AF>;
		close (AF);
		chomp($adrin);
		@adrss = split (/[$sep]/,$adrin);
	}
	if (!$adrin) {push (@adrss,$mymail);} 		
}	
sub xrtaml {
		($file = $INS{'frmName'}) =~ s/(\s|\.|\W)//g;
		$file = lc (substr($file,0,8));
	if ( -s "$enymre_path/$file.emt") {
		open(XT,"<$enymre_path/$file.emt");
			@xrtam = <XT>;
		close(XT);  }
}
sub wrds {
	if ($INS{'WRD'} =~ /(\W)/ || $INS{'WRD'} !~ /[a-zA-Z]/) {&err_msg('Password Must be Letters AND Numbers ONLY');}
	if (length ($INS{'WRD'}) > 15 || length ($INS{'WRD'}) < 6) {&err_msg('Password Must Be 6 to 15 characters');}
	if ($INS{'WRD'} ne $INS{'WRD2'}) {&err_msg('Passwords Entries Must Match');}
	$S_NDWO_RD = $INS{'WRD'};
	if (!$cryptit) {$M_YWO_RD = $INS{'WRD'};}
	else {$M_YWO_RD = crypt($INS{'WRD'}, substr($INS{'WRD'},2,2));}
}
sub mailtime {
	my $gmtPM = $gmtPlusMinus;
	my($secs,$mins,$hours,$mdays,$mons,$years,$wdays,$w,$ww,$www);
    my(@wkdy) = qw~Sun Mon Tue Wed Thu Fri Sat~;
    my(@mnth)=qw~Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec~;
		($secs,$mins,$hours,$mdays,$mons,$years,$wdays) = (gmtime(time + $gmtPM));
		if ($years > 99) {$years = 2000 + ($years - 100);}
		elsif ($years < 100) {$years = "19$years";}
	$w = $gmtPM /60 /60; ($ww = $w) =~ s/\..*//; ($www = $w) =~ s/$ww//;	$www = (60 * $www);
	return sprintf("$wkdy[$wdays], %02d $mnth[$mons] %04d %02d:%02d:%02d %+03d%02d (GMT)",$mdays,$years,$hours,$mins,$secs,$ww,$www);
}
sub errs {print "Content-type: text/html\n\n"; require "$modules_path/ennyerr.pl"; exit;}
sub err_msg {($mymail,$tmpp) = split(/:/,$mymail); print "Content-type: text/html\n\n"; require "$modules_path/ennyemsg.pl"; exit;}

	@pairs = split(/&/, $query_string);
	foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$name =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/~!/ ~!/g;
		$name =~ s/~!/ ~!/g;
		$name =~ s/<([^>]|\n)*>//g; 
		$value =~ s/<([^>]|\n)*>//g; 
		$name =~ s/!--#(.|\n)*--//g;
		$value =~ s/!--#(.|\n)*--//g;
		$value =~ s/(\cC|\f|\e)//g;
		$name =~ s/(\0|`)//g;
		$value =~ s/(\0|`)//g;
		if ($name =~ /Subscribe/i && $value =~ /:0$/) {$preview = 0;}
	if ($INS{$name} && $value) {$INS{$name} .= " * $value";} else {$INS{$name} = $value;}
	} delete $INS{'fred'}; delete $INS{'fred.x'}; delete $INS{'fred.y'};

if (($ENV{'REMOTE_ADDR'} eq $ENV{'REMOTE_HOST'} || $ENV{'REMOTE_HOST'} !~ /[a-z][A-Z][0-9]/ ) && ($ENV{'REMOTE_ADDR'} =~ /(\d+)\.(\d+)\.(\d+)\.(\d+)/)) {
	$pk = pack('C4', $1, $2, $3, $4);
	$cnvrt = (gethostbyaddr($pk, 2))[0];
	if ($cnvrt) {$ENV{'REMOTE_HOST'} = $cnvrt;}
	else {$ENV{'REMOTE_HOST'} = $ENV{'REMOTE_ADDR'};}
}
if ($INS{opts} =~ /S/) {$cgi_url = $SSLcgi_url;}
	if (!defined $preview && $INS{opts} !~ /X/) {$preview = 1;}
if ($INS{'opts'} =~ /p/) {&wrds;}
if ($INS{'opts'} =~ /n/) {$nulls = 1;}
delete $INS{'WRD'};
delete $INS{'WRD2'};
if ($INS{opts} =~ /A/ && $INS{'adm'}) {require "$modules_path/ennyadm.pl"; &go_adm;}
@forms = sort (keys(%INS));
for($cnt = 0; $cnt < @forms; $cnt++) {
	$s1 = $tmp = $s2 = "";
	if ($forms[$cnt] =~ /_(.*)$/) {$s1 = $1;}
	push (@tlen,$s1) if $s1;
	($s2 = $forms[$cnt]) =~ s/(^..|_.+)//g;
	if ($s2 =~ /^Subscribe$/i && $INS{'opts'} =~ /E/ && $INS{$forms[$cnt]} !~ /:0$/) {
		($savelist = $INS{$forms[$cnt]}) =~ s/:.$//; require "$modules_path/ennymail.pl"; &do_elist; undef $savelist;	}
	if ($forms[$cnt] ne "Total.Value") {push(@labels,$s2);} else {push(@labels,"Total Value");}
	if ($s1 =~ /r/ && $INS{$forms[$cnt]} !~ /[a-zA-Z0-9]/) {
	$err_lst .= "<b>$labels[$cnt]</b> <font color=\"#000000\">is a <b>required</b> item</font><br>";}
	if ($s1 =~ /t/ && $INS{$forms[$cnt]} =~ /\d+/) {$INS{$forms[$cnt]} = sprintf("%0.2f",$INS{$forms[$cnt]}) if $INS{$forms[$cnt]} && $INS{'opts'} =~ /j/; ($tmp = $INS{$forms[$cnt]}) =~ /\d+\.\d+/; $bigTtl += $tmp if $tmp;	}
	if ($s1 =~ /[^H](\d+)/) {($l1 = $s1) =~ s/\D//g; &chk_len($l1,$INS{$forms[$cnt]},$cnt);}
	if ($s2 =~ /^subject$/i) {$sbj = $INS{$forms[$cnt]};}
	if ($s2 =~ /^email$/i) {$from_e = $INS{$forms[$cnt]}; $INS{$forms[$cnt]} =~ s/,//g; &chk_addr($INS{$forms[$cnt]});}
}
	&errs if $err_lst; $bigTtl = sprintf("%0.2f",$bigTtl) if $bigTtl && $INS{'opts'} =~ /J/;
	if ($preview && !$INS{'shwprev'}) {require "$modules_path/ennyprev.pl"; &prev;}
	elsif (!$preview || $INS{'shwprev'}) {require "$modules_path/ennysend.pl"; &sendit;}
		else {require "$modules_path/ennysend.pl"; &sendit;}
exit(0);
